.386
.model flat,stdcall
option casemap:none

include WinSock2Client.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL bufDisplay[256]:BYTE

LOCAL bufEax[16]:BYTE

LOCAL bufFD[16]:BYTE

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.elseif eax==Connect
			invoke WSAStartup, 202h,addr wsadata 
			.if eax!=NULL 
					invoke MessageBox,hWnd,CTEXT("Unable to WSAStartup()"),CTEXT("Error"),MB_ICONERROR
					invoke WSACleanup				
			.endif
			invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use 
			.if eax==INVALID_SOCKET 
					invoke MessageBox,hWnd,CTEXT("Unable to socket()"),CTEXT("Error"),MB_ICONERROR
					invoke WSACleanup
			.endif
			mov sock,eax
			 
			invoke WSAAsyncSelect, sock, hWnd,WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE 
					            ; Register interest in connect, read and close events. 
			.if eax==SOCKET_ERROR 
						invoke MessageBox,hWnd,CTEXT("Unable to WSAASyncSelect"),CTEXT("Error"),MB_ICONERROR
						invoke WSACleanup
			.endif 
			
				mov sin.sin_family, AF_INET 
				invoke htons, Port                    ; convert port number into network byte order first 
				mov sin.sin_port,ax                  ; note that this member is a word-size param. 
				invoke inet_addr, addr IPAddress    ; convert the IP address into network byte order 
				mov sin.sin_addr,eax 
				invoke connect,sock,addr sin,sizeof sin 
				.if eax==SOCKET_ERROR            ; assuming we use non-blocking mode, connect 
				                                                            ; will always return SOCKET_ERROR 
				    invoke WSAGetLastError            ; retrieve the actual error code 
				    .if eax!=WSAEWOULDBLOCK        ; if it's not WSAEWOULDBLOCK 
						invoke MessageBox,hWnd,CTEXT("Unable to connect()"),CTEXT("Error"),MB_ICONERROR
						invoke WSACleanup				       					       ; it means a true error occurred 
				    .endif 
				.endif
			
			
		.endif
;	.elseif eax==WM_SIZE
    .elseif uMsg==WM_SOCKET            ; the message we specified in WSAAsyncSelect 


invoke dw2a, eax, addr bufEax

invoke dw2a, FD_ACCEPT, addr bufFD

invoke szCatStr, addr bufDisplay, CTEXT("EAX: ")

invoke szCatStr, addr bufDisplay, addr bufEax

invoke szCatStr, addr bufDisplay, CTEXT(" -- FD_ACCEPT: ")

invoke szCatStr, addr bufDisplay, addr bufFD

        invoke MessageBox,hWnd,eax,CTEXT("Error"),MB_ICONERROR       
        mov eax,lParam 
        .if ax==FD_CONNECT            ; the low word of lParam contains the event code. 
            shr eax,16                              ; the error code (if any) is in the high word of lParam 
            .if ax==NULL 
				invoke MessageBox,hWnd,CTEXT("Connected"),CTEXT("Error"),MB_ICONERROR
                
            .else 
                
            .endif 
        .elseif    ax==FD_READ 
				invoke MessageBox,hWnd,CTEXT("FD_READ called."),CTEXT("Error"),MB_ICONERROR

            shr eax,16 
            .if ax==NULL 
                invoke recv,sock,buffer1,1,0
                .if buffer1 == 1
 					invoke MessageBox,hWnd,CTEXT("Packet Received"),CTEXT("Error"),MB_ICONERROR               	
                .endif
            .else 
                
            .endif 
        .elseif    ax==FD_CLOSE 
            shr eax,16 
            .if ax==NULL 
               
            .else 
                 
            .endif 
        .endif 

	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
